<?php

namespace AMZcockpitDoctrine\Repository;
use AMZcockpitDoctrine\Entity\KeywordTracking;
use Doctrine\ORM\QueryBuilder;

/**
 * KeywordTrackingRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class KeywordTrackingItemRepository extends \Doctrine\ORM\EntityRepository
{
    public function getKeywordsTrackingItemsToFetch()
    {
        $qb = $this->createQueryBuilder('kti')->select('kti');
        $qb->where(
            $qb->expr()->orX(
                $qb->expr()->lte('kti.nextSchedule',':date'),
                $qb->expr()->isNull('kti.nextSchedule')
            )
        )
        ->setParameter('date',new \DateTime('now'));
        $qb->andWhere($qb->expr()->eq('kti.isProcessing', ":isProcessing"))
            ->setParameter('isProcessing', false);
        $qb->orderBy('kti.nextSchedule', 'ASC');
        $qb->setMaxResults(1);

        return  $qb->getQuery()->getOneOrNullResult();
    }

    public function getActiveProcessCount() {

        $qb = $this->createQueryBuilder('kti');
        $qb->select('COUNT(kti)')
            ->andWhere($qb->expr()->eq('kti.isProcessing',':isProcessing'))
            ->setParameter('isProcessing',true);

        return $qb->getQuery()->getSingleScalarResult();
    }
}
